# The Zulip Roadmap

Zulip has received a great deal of interest and attention since it was
released as free and open source software by Dropbox.  That attention
has come with a lot of active development work from members of the
Zulip community.

From when Zulip was released in September 2015 through today (November
2017), more than 350 people have contributed over 5000 pull requests to the
various Zulip repositories. So a lot of what gets done is driven by
contributor interest. That being said, our focus areas for the next few
months are:
* The mobile experience
* Visual polish of the main webapp
* Building out our API, bots and integrations framework
* Onboarding

We also use the [blocker][label-blocker] and [high priority][label-high]
labels in the main server repository to more granularly track issues that
the project's leadership believes would significantly improve the project.
We should emphasize that the majority of issues resolved in regular
Zulip development are not tagged with one of these labels; while it's
essential to make progress on priority projects, the Zulip community feels
strongly that all the little issues are, in aggregate, just as important as
priority projects.

We welcome participation from the community in influencing the Zulip
roadmap.  If a bug or missing feature is causing significant pain for your
organization, we appreciate your commenting to that effect, either in
[chat.zulip.org](../contributing/chat-zulip-org.md) or on the
relevant GitHub issue, with an explanation of how the issue impacts
your use case. See [Reporting issues](contributing.html#reporting-issues)
for more information.

[label-blocker]:
https://github.com/zulip/zulip/issues?q=is%3Aissue+is%3Aopen+label%3A%22priority%3A+blocker%22
[label-high]:
https://github.com/zulip/zulip/issues?q=is%3Aissue+is%3Aopen+label%3A%22priority%3A+high%22
